#!/usr/bin/python3

import sys,json

#if any impacting changes to this plugin kindly increment the plugin version here.
PLUGIN_VERSION = "1"

#Setting this to true will alert you when there is a communication problem while posting plugin data to server
HEARTBEAT="true"


METRIC_UNITS = {'clock_drift_in_seconds':'Seconds'}

def metricCollector():
   data = {}
   data['plugin_version'] = PLUGIN_VERSION
   data['heartbeat_required']=HEARTBEAT 
   try:
        import datetime
        import pytz
        e = datetime.datetime.now()         #current system time in local format
        systemTime = e.astimezone(pytz.UTC)     #current system time in utc format

        import ntplib
        from datetime import datetime, timezone
        c = ntplib.NTPClient()
        # Provide the respective ntp server ip in below function
        response = c.request('pool.ntp.org', version=3)
        response.offset
        ntpTime=datetime.fromtimestamp(response.tx_time, timezone.utc)        #utc time from ntp server


        if ntpTime>=systemTime:
            clockdrift=ntpTime-systemTime
        else:
            clockdrift=systemTime-ntpTime
        
        clockdrift_in_sec=clockdrift.total_seconds()  
        data['clock_drift']=str(clockdrift)
        data['clock_drift_in_seconds']=clockdrift_in_sec
        
   except Exception as e:
        data["status"] = 0
        data["msg"] = str(e)
        
   return data

if __name__ == "__main__":
      result = metricCollector()
      print(json.dumps(result, indent=4, sort_keys=True))